<html>
<head>
	<link href="https://fonts.googleapis.com/css?family=Roboto" rel="stylesheet">
	<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
	<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/themes/smoothness/jquery-ui.css">
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.12.2/css/bootstrap-select.min.css">
	<link rel="stylesheet" href="css/styles.css">
	
	<link href="https://gitcdn.github.io/bootstrap-toggle/2.2.2/css/bootstrap-toggle.min.css" rel="stylesheet">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/d3/3.5.17/d3.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/d3plus/1.9.8/d3plus.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
	<script src="https://gitcdn.github.io/bootstrap-toggle/2.2.2/js/bootstrap-toggle.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.17.1/moment.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.47/js/bootstrap-datetimepicker.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.12.2/js/bootstrap-select.min.js"></script>

	<script>
	  $( function() {
		$.widget( "custom.combobox", {
		  _create: function() {
			this.wrapper = $( "<span>" )
			  .addClass( "custom-combobox" )
			  .insertAfter( this.element );
	 
			this.element.hide();
			this._createAutocomplete();
			this._createShowAllButton();
		  },
	 
		  _createAutocomplete: function() {
			var selected = this.element.children( ":selected" ),
			  value = selected.val() ? selected.text() : "";
	 
			this.input = $( "<input>" )
			  .appendTo( this.wrapper )
			  .val( value )
			  .attr( "title", "" )
			  .addClass( "custom-combobox-input ui-widget ui-widget-content ui-state-default ui-corner-left" )
			  .autocomplete({
				delay: 0,
				minLength: 0,
				source: $.proxy( this, "_source" )
			  })
			  .tooltip({
				classes: {
				  "ui-tooltip": "ui-state-highlight"
				}
			  });
	 
			this._on( this.input, {
			  autocompleteselect: function( event, ui ) {
				ui.item.option.selected = true;
				this._trigger( "select", event, {
				  item: ui.item.option
				});
			  },
	 
			  autocompletechange: "_removeIfInvalid"
			});
		  },
	 
		  _createShowAllButton: function() {
			var input = this.input,
			  wasOpen = false;
	 
			$( "<a>" )
			  .attr( "tabIndex", -1 )
			  .attr( "title", "Show All Items" )
			  .tooltip()
			  .appendTo( this.wrapper )
			  .button({
				icons: {
				  primary: "ui-icon-triangle-1-s"
				},
				text: false
			  })
			  .removeClass( "ui-corner-all" )
			  .addClass( "custom-combobox-toggle ui-corner-right" )
			  .on( "mousedown", function() {
				wasOpen = input.autocomplete( "widget" ).is( ":visible" );
			  })
			  .on( "click", function() {
				input.trigger( "focus" );
	 
				// Close if already visible
				if ( wasOpen ) {
				  return;
				}
	 
				// Pass empty string as value to search for, displaying all results
				input.autocomplete( "search", "" );
			  });
		  },
	 
		  _source: function( request, response ) {
			var matcher = new RegExp( $.ui.autocomplete.escapeRegex(request.term), "i" );
			response( this.element.children( "option" ).map(function() {
			  var text = $( this ).text();
			  if ( this.value && ( !request.term || matcher.test(text) ) )
				return {
				  label: text,
				  value: text,
				  option: this
				};
			}) );
		  },
	 
		  _removeIfInvalid: function( event, ui ) {
	 
			// Selected an item, nothing to do
			if ( ui.item ) {
			  return;
			}
	 
			// Search for a match (case-insensitive)
			var value = this.input.val(),
			  valueLowerCase = value.toLowerCase(),
			  valid = false;
			this.element.children( "option" ).each(function() {
			  if ( $( this ).text().toLowerCase() === valueLowerCase ) {
				this.selected = valid = true;
				return false;
			  }
			});
	 
			// Found a match, nothing to do
			if ( valid ) {
			  return;
			}
	 
			// Remove invalid value
			this.input
			  .val( "" )
			  .attr( "title", value + " didn't match any item" )
			  .tooltip( "open" );
			this.element.val( "" );
			this._delay(function() {
			  this.input.tooltip( "close" ).attr( "title", "" );
			}, 2500 );
			this.input.autocomplete( "instance" ).term = "";
		  },
	 
		  _destroy: function() {
			this.wrapper.remove();
			this.element.show();
		  }
		});
	 
		$( "#combobox" ).combobox();
		$( "#toggle" ).on( "click", function() {
		  $( "#combobox" ).toggle();
		});
	  } );
	  </script>
	
</head>
<body>
	<div id="loading"><div><img id="loading-image" src="css/images/spin.svg"/><br>Procesando datos...</div></div>
	<div id="menu">
		<nav class="navbar navbar-inverse">
			<div class="container-fluid">
				<div class="navbar-header">
					
				  <a class="navbar-brand" href="#">UNIVERSITYHACK 2017 DATATHON</a>
				  <div class="collapse navbar-collapse" style="display:inline-block !important;" id="bs-example-navbar-collapse-1">
					  <ul class="nav navbar-nav navbar-right">
						<li><a href="index.php"><b>Estadísticas básicas</b></a></li>
						<li class="active"><a href="index2.php">Planifica tus compras <span class="sr-only">(current)</span></a></li>
						<li><a style="color:#FF6A00" data-toggle="modal" data-target="#myModal"><b style="cursor:pointer;">¿Cómo usar esta herramienta?</b></a></li>
					  </ul>
					</div>
				</div>
			</div>
		</nav>
	</div>
	<div class="container">
		<div id="title">
			<center><h1>PLANIFICA TUS COMPRAS EN VALENCIA (CAPITAL)</h1></center>
		</div>
		<div class="row">
			<div class="col-sm-3" style="padding-top: 5px;text-align: right;">
				<div class ="form-group">
					<span>Busca tu localidad de destino: </span>
				</div>
			</div>
			<div class='col-sm-3'>
				<div class="form-group">
					<div class="ui-widget">
					  
						<select id="combobox"></select>
					</div>
				</div>
			</div>
			<div class="col-xs-2" style="padding-top: 5px;text-align: right;">
				<div class ="form-group">
					<span>Elige el día que comprarás: </span>
				</div>
			</div>
			<div class='col-sm-2'>
				<div class="form-group">
					<div class='input-group date' id='superior'>
						<input type='text' class="form-control" />
						<span class="input-group-addon">
							<span class="glyphicon glyphicon-calendar"></span>
						</span>
					</div>
				</div>
			</div>
			<div class='col-sm-1'>
				<div class="form-group">
					<button type="button" id="procesar" class="btn btn-primary">Procesar</button>
				</div>
			</div>
			
        </div>
		<div class="first_col" id="barchart">
			<div id="visualization"></div>
			
		</div>
		<div class="first_col" id="piechart">
			<div id="visualization"></div>
		</div>
		<div class="second_col" style="display:none;">
			<div class="alert alert-success" role="alert"></div>
		</div>

	</div>
	<!-- Modal -->
	<div id="myModal" class="modal fade" role="dialog">
		<div class="modal-dialog">

			<!-- Modal content-->
			<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal">&times;</button>
				<h4 class="modal-title">¿Cómo usar esta herramienta?</h4>
			</div>
			<div class="modal-body">
				<p>Esta herramienta te ayudará a que tus compras sean mucho mas expeditas.</p>
				<p>Lo primero que debes hacer es seleccionar el área postal de la localidad en la cual piensas comprar</p>
				<p><img src="images/localidad.png"></p>
				<p>Posteriormente debes elegir el día que quieres comprar</p>
				<p><img src="images/dia.png"></p>
				<p>Finalmente debes hacer click en el botón</p>
				<p><img src="images/boton.png"></p>
				<p>Para ayudarte en tus compras, se utiliza el día que elegiste, pero correspondiente a los años 2015 y 2016, que es en donde se observa el comportamiento histórico de esas transacciones. Con esto, el sistema recomendará el horario en el que menos operaciones se realizaron para que hagas tus compras con tranquilidad.</p>
				<p>En caso de que no puedas asistir en el horario recomendado, puedes elegir cualquier otro que aparezca en el gráfico de torta, con el cuidado de elegir los trozos mas pequeños dentro horario que tengas disponible.</p>
				<p><img src="images/piechart.png"></p>
				<p>Debes recordar, que al igual que la herramienta anterior, acá puedes clickear las barras del gráfico de barras, de esta forma la recomendación será para el tipo de comercio que haz seleccionado</p>
				<p><img src="images/barchart.png"></p>
				<p>Finalmente, el sistema, para recomendar, sólo utiliza el período comprendido entre las 10:00 y las 20:00 hrs.</p>
				
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
			</div>
		</div>

	</div>
	<script>
		var FESTIVOS = ["01/01","06/01","22/01","27/02","19/03","24/03","25/03","28/03","04/04","07/04","01/05","24/06","29/06","15/08","09/10","12/10","01/11","06/12","08/12","25/12","26/12"]
		$( document ).ajaxStart(function() {
			$("#loading").show();
		});
		
		$( document ).ajaxStop(function() {
			$("#loading").hide();
		});
		
		function barchart(data){
			$("#barchart #visualization").empty()
			var visualization = d3plus.viz()
				.container("#barchart #visualization")
				.data(data)
				.type("bar")
				.id("Tipo de Comercio")
				.x("Tipo de Comercio")
				.y("transacciones")
				.resize( true )
				.mouse({
						"click":function(o){
								day = $("#superior input").val()
								month = day.split("/")[1]+"/"+day.split("/")[2]
								day1 = "2016/"+month
								day2 = "2015/"+month
								if (FESTIVOS.includes(month) == false){
									day0 = "2017/"+day.split("/")[1]+"/"+day.split("/")[2]
									day1 = "2016/"+day.split("/")[1]+"/"+day.split("/")[2]
									day2 = "2015/"+day.split("/")[1]+"/"+day.split("/")[2]
									day0 = new Date(day0)
									day1 = new Date(day1)
									day2 = new Date(day2)
									day1.setDate(day1.getDate() - (day1.getDay()-day0.getDay()))
									day2.setDate(day1.getDate() - (day2.getDay()-day0.getDay()))
									day1 = day1.toLocaleString().split(" ")[0].split("/")
									day1 = day1[2]+"/"+day1[1]+"/"+day1[0]
									day2 = day2.toLocaleString().split(" ")[0].split("/")
									day2 = day2[2]+"/"+day2[1]+"/"+day2[0]
								}
								$.post("webservice/get_hour.php",{"name":o["Tipo de Comercio"],"ysup":day1,"ysup2":day2,"zip":$("#combobox").val()},function(data){
								
									
									json = $.parseJSON(data)		
									piechart(json,o["Tipo de Comercio"])
								})
							
							}
					})
				.draw()
		}
		
		function piechart(data,com){
			minimo = 9999999999999
			date = 0
			for (d in data){
				if (data[d].date != "08-10" && data[d].date != "06-08" && data[d].date != "00-02" && data[d].date != "02-04" && data[d].date != "04-06" && data[d].date != "22-24" && data[d].date != "20-22"){
					if (data[d].transacciones < minimo){						
						minimo = data[d].transacciones
						date = data[d].date
					}
				}
			}
			$(".second_col div").html("Si deseas ahorrar tiempo, te recomendamos efectuar tus compras en "+com.toLowerCase()+" en el tramo horario "+date)
			$(".second_col").show()
			
			$("#piechart #visualization").empty()
			var visualization = d3plus.viz()
				.container("#piechart #visualization")
				.data(data)
				.type("pie")
				.id("date")
				.size("transacciones")
				.resize( true )
				.format("es_ES")
				.draw()
		}
		
		function treemap(data,type){
			$("#treemap #visualization").empty()
			var visualization = d3plus.viz()
					.container("#treemap #visualization")  // container DIV to hold the visualization
					.data(data)  // data to use with the visualization
					.type("tree_map")   // visualization type
					.id("name")         // key for which our data is unique on
					.size(type)      // sizing of blocks
					.format("es_ES")
					.draw()
		}
		
		function linechart(data,type){
			$("#linechart #visualization").empty()
			var visualization = d3plus.viz()
			.container("#linechart #visualization")  // container DIV to hold the visualization
			.data(data)  // data to use with the visualization
			.type("line")       // visualization type
			.id("name")         // key for which our data is unique on
			.text("Tipo de Comercio")       // key to use for display text
			.y(type)         // key to use for y-axis
			.x("date")          // key to use for x-axis
			.resize( true )
			.format("es_ES")
			.draw()  
		}

		$(document).ready(function(){
			$('#superior').datetimepicker({
				format:"YYYY/MM/DD",
				
				
				defaultDate:moment({}),
				useCurrent:false,
				
			});

			$.post("webservice/get_list.php",
				{},function( data ) {
					json = $.parseJSON(data)
					for (d in json){
						$("#combobox").append(new Option(json[d]+" ("+d+")",d))
					}
					
				})
			
			$("#procesar").click(function(){
				$.post("webservice/get_sector2.php",
					{"ysup":$("#superior input").val(),"name":$("#combobox").val()},function( data ) {
						json = $.parseJSON(data)
						barchart(json,"importe")
						day = $("#superior input").val()
						month = day.split("/")[1]+"/"+day.split("/")[2]
						day1 = "2016/"+month
						day2 = "2015/"+month
						if (FESTIVOS.includes(month) == false){
							day0 = "2017/"+day.split("/")[1]+"/"+day.split("/")[2]
							day1 = "2016/"+day.split("/")[1]+"/"+day.split("/")[2]
							day2 = "2015/"+day.split("/")[1]+"/"+day.split("/")[2]
							day0 = new Date(day0)
							day1 = new Date(day1)
							day2 = new Date(day2)
							day1.setDate(day1.getDate() - (day1.getDay()-day0.getDay()))
							day2.setDate(day1.getDate() - (day2.getDay()-day0.getDay()))
							day1 = day1.toLocaleString().split(" ")[0].split("/")
							day1 = day1[2]+"/"+day1[1]+"/"+day1[0]
							day2 = day2.toLocaleString().split(" ")[0].split("/")
							day2 = day2[2]+"/"+day2[1]+"/"+day2[0]
						}
						$.post("webservice/get_hour.php",{"name":"","ysup":day1,"ysup2":day2,"zip":$("#combobox").val()},function(data){
							json = $.parseJSON(data)
							piechart(json," todas las áreas ")
						})
						//~ $.post("webservice/get_comerce.php",{"name":""},function(data){
							//~ json = $.parseJSON(data)
							//~ treemap(json,"importe")
						//~ })
						
					})
			})
			
		})
	
	</script>
</body>
</html>
